/*
 GENERATE POISSON RANDOM NUMBER IF alambda IS LESS THAN xover
 OR ELSE GENERATE GAUSSIAN RANDOM NUMBER
*/

#include <cstdio>
#include <cmath>

//#include "DIGRand.h"
#include <DIGRand/DIGRand.h>
//#include "DIGGauss.h"
#include <DIGRand/DIGGauss.h>
//#include "DIGPoisson.h"
#include <DIGRand/DIGPoisson.h>


int Poisson(double pALambda)
{
  static const double xover = 36.0;

  int n;

  double a, e, y;


  if(pALambda >= xover) {
    int g = (int) (Gauss(pALambda, (double) sqrt(pALambda)) + 0.5);
    n = (g > 0) ? g: 0;
  }
  else {
    y = Rand();
    n = 0;
    e = (double) exp(-pALambda);
    a = y;

    while(a >= e) {
      n++;
      y = Rand();
      a *= y;
    }
  }
  return n;
}      
