/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/GeometricBehaviour.cpp $
 $LastChangedRevision: 81 $
 $Date: 2014-07-02 11:07:09 -0400 (Wed, 02 Jul 2014) $
 $Author: olangthaler $
 ***********************************************************
 */

#include "GeometricBehaviour.h"
#include "BasisFunctionPixel.h"
#include "BasisFunctionBlob.h"
#include "blob.h"
#include "anglst.h"

GeometricBehaviour::GeometricBehaviour()
{
}

GeometricBehaviour::~GeometricBehaviour()
{
}

GeometricBehaviour* GeometricBehaviour::getInstance()
{

	GeometricBehaviour* strategy;

	if (Blob.pix_basis)
	{
		strategy = new BasisFunctionPixel();
	}
	else
	{
		strategy = new BasisFunctionBlob();
	}

	return strategy;
}

INTEGER GeometricBehaviour::getArrayIndex(INTEGER row, INTEGER column)
{
	return row * GeoPar.nelem + column;
}

void GeometricBehaviour::getPixelPosition(INTEGER arrayIndex, INTEGER* row, INTEGER* column)
{
	*row = arrayIndex / GeoPar.nelem;
	*column = arrayIndex % GeoPar.nelem;
}

