/*      
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/bbldlst.cpp $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 THIS SUBROUTINE COMPUTES THE MAXIMAL SIZE OF THE LIST AND WEIGHT
 ARRAYS NEEDED BY BRAY AND BWRAY.  IT ALLOCATES
 THE MAXIMUM OF THESE VALUES FOR THE LIST AND WEIGHT ARRAYS.
 */

#include <cstdlib>     
#include <cstdio>

#include "blkdta.h"
#include "geom.h"
#include "blob.h"
#include "uiod.h"

void Blob_class::bbldlst(INTEGER** lbase, REAL** wbase)
{
	INTEGER npts;

	if (GeoPar.strip)
	{
		npts = (INTEGER) (Blob.diag * (2 * GeoPar.pinc / Blob.delta + 1));
		// use similar reasoning for the line case for pinc/2 instead of blob.support
	}

	if (GeoPar.line)
	{
		npts = (INTEGER) (Blob.diag * (4 * Blob.support / Blob.delta + 1));
	}
	*lbase = new INTEGER[npts];
	*wbase = new REAL[npts];
}

