/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/bpseudo.cpp $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************
 */

// COMPUTE THE PSEUDO PROJECTION OF RAY NR IN PROJECTION NP OF
// THE PICTURE PICT IN THE BLOB CASE.
#include <cstdio>

#include "blkdta.h"
#include "modefl.h"
#include "blob.h"
#include "uiod.h"

REAL Blob_class::bpseudo(REAL* pict, INTEGER np, INTEGER nr, INTEGER* list, REAL* weight, INTEGER* numb, REAL* snorm, BOOLEAN line, BOOLEAN constr)
{
	int nb, k;
	REAL pictk;
	REAL sum = 0.0;

	if (!line)
	{
		Blob.bray(np, nr, list, weight, numb, snorm);
	}
	else
	{
		Blob.bwray(np, nr, list, weight, numb, snorm);
	}

	if (*numb != 0)
	{
		for (nb = 0; nb < *numb; nb++)
		{
			k = list[nb];
			pictk = pict[k];
			if (constr)
			{
				if (Modefl.lofl)
					pictk = MAX0(pictk, Modefl.lower);
				if (Modefl.upfl)
					pictk = MIN0(pictk, Modefl.upper);
			}
			sum += pictk * weight[nb];
		}
	}
//  pseudo=sum;

	if (trace > 5)
	{
		fprintf(output,
				"\n          bpseudo  np = %5i  nr = %5i  bpseudo = %9.4f", np,
				nr, sum);
	}
	return sum;
}
