/*
 **********************************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/disply.cpp $
 $LastChangedRevision: 79 $
 $Date: 2014-07-01 15:33:39 -0400 (Tue, 01 Jul 2014) $
 $Author: agulati $
 **********************************************************************
 */

#include <cstdio>

#include "blkdta.h"
#include "uiod.h"

#include "int2str.h"
#include "disp.h"

#include "recfile.h"
#include "infile.h"

#include "disply.h"

void disply()
{
	// was in post but it is realy local
	CHAR prjnam[81];
	CHAR phnnam[81];
	CHAR recnam[81];

	// was in geo but it is realy local
	INTEGER nelem;
	INTEGER area;

	INTEGER word, flags[51];
	unsigned int count, iter;
	CHAR algn[5];
	REAL scale;
	REAL* Recon;
	BOOLEAN eol, phan;

	phan = FALSE;
	scale = 1.0;

	static const INTEGER hphan = CHAR2INT('p', 'h', 'a', 'n');
	static const INTEGER hscal = CHAR2INT('s', 'c', 'a', 'l');

	// modified calls to getwrd() to use the 4-parameter version. Lajos, Dec 13, 2004
	static const INTEGER disply_codes[2] =
	{ CHAR2INT('p', 'h', 'a', 'n'), CHAR2INT('s', 'c', 'a', 'l') };

	for (;;)
	{
		word = InFile.getwrd(FALSE, &eol, disply_codes, 2);
		if (eol)
			break;

		switch (word)
		{
		case hphan:
			phan = TRUE;
			break;

		case hscal:
			scale = InFile.getnum(FALSE, &eol);
			break;

		}
	}

	if (RecFile.Open("recfil") != 0)
	{
		fprintf(output, "\n **** unable to open recfil");
		fprintf(output, "\n **** DISPLAY execution aborted\n");
		return;
	}

	if (RecFile.GetNelem(&nelem) != 0)
	{
		;
	}

	if (RecFile.GetProjName(prjnam) != 0)
	{
		;
	}

	area = nelem * nelem;
	//GeoPar.midpix = (GeoPar.nelem + 1) / 2;

	InFile.listit(flags);

	Recon = new REAL[area];

	// if phantom selected
	if (phan)
	{
		if (RecFile.ReadPhan(phnnam, Recon) != 0)
		{
			fprintf(output, "\n **** phantom not present\n");
		}
		else
		{
			fprintf(output, "\n     display of phantom\n");

			fprintf(output, "\n     phantom name:    %s", phnnam);

			disp(Recon, nelem, nelem, scale, output);
		}
	}

	while (RecFile.ReadRec(recnam, algn, &count, &iter, Recon) == 0)
	{

		// if selected
		if (flags[iter - 1] != 0)
		{

			fprintf(output, "\n\n     reconstruction using %s iter %4i\n", algn,
					count);

			fprintf(output, "\n     projection data: %s", prjnam);

			if (iter > 0)
			{
				fprintf(output, "\n     execution name:  %s", recnam);
			}

			disp(Recon, nelem, nelem, scale, output);
		}
	}

	delete[] Recon;  // bug 92 - Lajos - 03/02/2005

	fprintf(output, "\n");  // end of file reached
	RecFile.Close();
	return;
}
