/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/getwrd.cpp $
 $LastChangedRevision: 80 $
 $Date: 2014-07-01 21:01:54 -0400 (Tue, 01 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 GETWRD RETURNS AS ITS VALUE THE FIRST FOUR LETTERS  OF THE NEXT
 STRING OF ALPHA CHARACTERS IN THE INPUT RECORD
 CALLS FUNCTION 'GETNXT'.  RETURNS EOL = .TRUE. WHEN END OF LINE
 IS REACHED.
 REVISED BY G. FRIEDER AND M. MCKAY, JULY 1981
 */

#include <cstdio>
#include <cctype>

#include "blkdta.h"
//#include "alphab.h"

#include "wrdpack.h"

#include "inputfile.h"

//BOOLEAN isalph(CHAR letter);   

// removed old (2-parameter) version of getwrd. Lajos, Dec 16, 2004
INTEGER InputFile_class::getwrd(BOOLEAN NewLine, BOOLEAN* eol, const INTEGER *expect, int nexpect)
{
	BOOLEAN ew;

	INTEGER word, i;
	CHAR nxtchr;

	word = CHAR2INT(' ', ' ', ' ', ' ');
	*eol = FALSE;

	if (NewLine)
		getnxt(FALSE);

	while (true)
	{
		// SCAN TILL THE FIRST ALPHA CHARACTER IS HIT
		do
		{
			if (++ptr > DATASIZ)     // bug 190 - swr - 12/09/05
			{ // ALPHA CHARACTER NOT FOUND
				*eol = TRUE;
				return CHAR2INT(' ', ' ', ' ', ' ');
			}
			nxtchr = data[ptr];
		} while (!(isalpha(nxtchr)));

		// THE FIRST ALPHA HAS BEEN FOUND,  STRING THE FIRST FOUR LETTERS
		ptr++;
		ptr--;

		ew = wrdpack(data, &ptr, &word);

		// SKIP ANY CHARACTER AFTER THE FIRST FOUR TILL A BLANK IS HIT

		if (!ew)
		{
			do
				ptr++;
			while (data[ptr] != ' ');
		};

		// RETURN IF EXPECTED WORD HAS BEEN FOUND
		for (i = 0; i < nexpect; i++)
		{
			if (word == expect[i])
				return word;
		}
	}
}

