/* 
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/noise.h $
 $LastChangedRevision: 80 $
 $Date: 2014-07-01 21:01:54 -0400 (Tue, 01 Jul 2014) $
 $Author: agulati $
 ***********************************************************
 */

#ifndef NIOISE_H
#define NIOISE_H

#include "blkdta.h"

// bug221 - moved noise code to this class - swr - 03/03/07

extern class Noise_class
{
public:
	INTEGER quanin;REAL quanmn;REAL quancm;BOOLEAN sctnfl;REAL sctnpk;REAL sctnwd;BOOLEAN ultnfl;REAL ultnmn;REAL ultnsd;BOOLEAN addnfl;REAL addnmn;REAL addnsd;
	void setAdditiveNoise(REAL mean, REAL std);REAL additiveNoise(REAL value);
	void setMultiplicativeNoise(REAL mean, REAL std);REAL multiplicativeNoise(REAL value);
	void setScatter(REAL peak, REAL width);
	void scatterNoise(REAL* projection);
	void setQuantumNoise(INTEGER type, REAL mean, REAL calibration);
	void setQuantumNoise();REAL applyQuantumNoise(INTEGER np, INTEGER nr, REAL sum);REAL raysum(REAL raysum);REAL computeAttenuation( INTEGER np, INTEGER nr, REAL ind);
	void resetNoise(); // jklukowska, bug 263, in case the noise was set
					   // previously, we need to reset it to initial values
	Noise_class();
	~Noise_class();
private:
	REAL* sctcnt;REAL* sctwts;REAL* calray;INTEGER nsctr;REAL back;REAL aback;REAL cback;REAL c;INTEGER oldnp;
} NoisePar;

enum
{
	NONOISE = 0,
	CONSTANT_PROJECTION = 1,
	CONSTANT_RAY = 2,
	VARIABLE = 3,
	PET = 4
};

#endif
