/* 
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/projfile.h $
 $LastChangedRevision: 80 $
 $Date: 2014-07-01 21:01:54 -0400 (Tue, 01 Jul 2014) $
 $Author: agulati $
 ***********************************************************
 */

#ifndef SROJFILE_H
#define SROJFILE_H

#include <cstdio>

#include "blkdta.h"

#include "geom.h"
#include "spctrm.h"
#include "noise.h"
#include "anglst.h"

#include "DIGFileSnarkProj.h"

extern class SnarkPrjFile: private DIGFileSnarkProj
{
protected:

	unsigned INTEGER NumberOfRays;         // usrays
	unsigned INTEGER NumberOfProjections;  // prjnum
	char Angles, Reading, Writing;
	double* AnglesBuff;
public:
	SnarkPrjFile();
	//~SPRJFile();

	INTEGER Open(const char* FileName);INTEGER Open(const char* FileName, INTEGER usrays, INTEGER prjnum);

	INTEGER ReadHeader(char* name, Noise_class* Noise, spctrm_class* Spct, anglst_class* Anglst);

	INTEGER ReadProj(INTEGER np, REAL* data, unsigned INTEGER nsize);

	INTEGER WriteHeader(char* name, Geometry_class* Geo, Noise_class* Noise, spctrm_class* Spct);

	INTEGER WriteAngles(REAL* bth);INTEGER WriteProj(INTEGER np, REAL* iprjec);

	INTEGER Close();

} ProjFile;

#endif
