/*      
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/pseudo.cpp $
 $LastChangedRevision: 80 $
 $Date: 2014-07-01 21:01:54 -0400 (Tue, 01 Jul 2014) $
 $Author: agulati $
 ***********************************************************
 */

// COMPUTE THE PSEUDO PROJECTION OF RAY NR IN PROJECTION NP OF
// THE PICTURE PICT.
#include <cstdio>

#include "blkdta.h"
#include "modefl.h"
#include "uiod.h"

#include "ray.h"
#include "wray.h"
#include "pseudo.h"

REAL pseudo(REAL* pict, INTEGER np, INTEGER nr, INTEGER* list, REAL* weight,
		INTEGER* numb, REAL* snorm, BOOLEAN line, BOOLEAN constr)
{

	INTEGER nb, k;
	REAL pictk;
	REAL sum = 0.0;

	if (!line)
	{
		ray(np, nr, list, weight, numb, snorm);
	}
	else
	{
		wray(np, nr, list, weight, numb, snorm);
	}

	if (*numb != 0)
	{
		for (nb = 0; nb < *numb; nb++)
		{
			k = list[nb];
			pictk = pict[k];
			if (constr)
			{
				if (Modefl.lofl)
					pictk = MAX0(pictk, Modefl.lower);
				if (Modefl.upfl)
					pictk = MIN0(pictk, Modefl.upper);
			}
			sum += pictk * weight[nb];
		}
	}
	if (trace > 5)
	{
		fprintf(output,
				"\n          pseudo  np = %5i  nr = %5i  pseudo = %9.4f\n", np,
				nr, sum);
	}
	return sum;
}
