/* 
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/recfile.h $
 $LastChangedRevision: 94 $
 $Date: 2014-07-02 18:53:30 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************
 */

#ifndef RECFILE_H
#define RECFILE_H

#include <cstdio>

#include "DIGFileSnarkRec.h"
#include "blkdta.h"

// these are the methods associated with the reconstruction file class

extern class SnarkRecFile: private DIGFileSnarkRec
{

protected:

	unsigned INTEGER NumberOfElements;
	REAL PixelSize;
	unsigned INTEGER RecSetNum;
	unsigned INTEGER RecNum;

	REAL* DataBuffer;

	void FlipImage(REAL* Dst, REAL* Src);

public:

	INTEGER Open(const CHAR *FileName, INTEGER nelem, REAL pixsiz);
	INTEGER Open(const CHAR *FileName);

	INTEGER GetNelem(INTEGER *nelem);
	INTEGER GetPixSize(REAL *pixsize);
	INTEGER GetProjName(CHAR prjname[81]);
	INTEGER SetProjName(CHAR *prjname);

	INTEGER WritePhan(CHAR *phnname, REAL *data);
	INTEGER WriteRec(CHAR *recname, CHAR alg_name[4], unsigned INTEGER count, unsigned INTEGER iter, REAL *data);

	INTEGER ReadPhan(CHAR phnname[81], REAL *data);
	INTEGER ReadRec(CHAR recname[81], CHAR alg_name[4], unsigned INTEGER *count, unsigned INTEGER *iter, REAL *data);

	INTEGER Close();

	INTEGER SelectRec(unsigned INTEGER RecNum);

private:
	INTEGER ApplyLimits(unsigned int pArraySize, REAL* pData);

} RecFile;

#endif
