/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/recon.c $
 $LastChangedRevision: 94 $
 $Date: 2014-07-02 18:53:30 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 Previously part of :*/

/*--------------------------------------------------------------------------
 Super Snark V 1.0
 Written by Jingsheng Zheng... November 1992

 Modified by Jolyon Browne... June 1993
 ----------------------------------------------------------------------------*/

#include <string.h>
#include <strings.h>
#include <stdlib.h>

#include "experimenter.h"
#include "errorc.h"
#include "recon.h"

/*--------------------------------------------------------------------------

 This function echos the information stored in the file specified on
 line 4 of the SuperSNARK input sequence. This information is sent to the
 SNARK input stream.

 INPUTS:
 rec_flname - file containing information about the algorithms to be
 executed. This is the file specified on line 4 of the
 SuperSNARK input sequence.
 exp_num - experiment number.
 run_num - run number

 OUTPUTS:
 none
 ----------------------------------------------------------------------------*/

void recon(char* rec_flname, int exp_num, int run_num)
{
	char string[MAXLINESIZE];
	FILE *recfl;

	if ((recfl = fopen(rec_flname, "r")) == NULL)
	{
		errorc("error in opening file", rec_flname);
	}

	while ((fgets(string, sizeof(string), recfl)) != NULL)
	{
		while (isSkip(string)) //it's a comment line,
		{                    //echo it to output and read next line
			if (isComment(string))
				fprintf(pstream, "%s", string);
			if (fgets(string, sizeof(string), recfl) == NULL)
				break;
		}
		if (strncasecmp(string, "exec", 4) == 0)
		{
			fprintf(pstream, "%s", string);
			if ((fgets(string, sizeof(string), recfl)) != NULL)
			{
				while (isSkip(string)) //it's a comment line,
				{                    //echo it to output and read next line
					if (isComment(string))
						fprintf(pstream, "%s", string);
					if (fgets(string, sizeof(string), recfl) == NULL)
						break;
				}
				string[strlen(string) - 1] = '\0';
			}
			fprintf(pstream, "%s experiment= %d run= %d\n", string, exp_num, run_num);
		}
		else
		{
			fprintf(pstream, "%s", string);
		}
	}

	fclose(recfl);
}
