/** @file SnarkDisplay.hpp
    @package snark14Display
    @author Bruno M. Carvalho and Deniz Sarioz
    licensed under (open-source) QPL v1.0
    which accompanies this distribution in the file QPL
*/

#ifndef SNARKDISPLAY_H
#define SNARKDISPLAY_H

// #include <qvariant.h>
#include <qwidget.h>

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QFrame;
class QPushButton;
class rangewindow;
class openimageswindow;
class displaywindow;
class displayprojection;

class SnarkDisplay : public QWidget
{ 
    Q_OBJECT

public:
    SnarkDisplay( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
    ~SnarkDisplay();
    void allocSnarkimages(int ni);
    void freeSnarkimages(int ni);
    void allocDisplaywindows(int ni);
    void freeDisplaywindows(int ni);
    QFrame* Line1;
    QPushButton* linesbutton;
    QPushButton* imagesbutton;
    QPushButton* recfilbutton;
    QPushButton* rangebutton;
    QPushButton* projfilbutton;
    QPushButton* evalbutton;
    QPushButton* quitbutton;
    QPushButton* helpbutton;
private:
    rangewindow* myRangeWinP;
    openimageswindow* myOpenImagesWinP;
    displaywindow** displaywindowset;
    displayprojection* projwin;

public slots:
    void signalAllGlobals(bool on);
    void signalAllDifference(bool on);
    void signalAllIntensity(bool on);
    void updateGlobalThreshs();
private slots: 
    void callLines();
    void callOpenImages();
    void openRecfilFile(); 
    void callRange();
    void openPrjfilFile(); 
    void openEvalFile();
    void about();
};

#endif // SNARKDISPLAY_H
