/** @file line_real_set_t.hpp
    @package snark14Display
    @author Bruno M. Carvalho and Deniz Sarioz
    @description class line_real_set_t definition
    licensed under (open-source) QPL v1.0
    which accompanies this distribution in the file QPL
*/
#ifndef _LINE_REAL_SET_T
#define _LINE_REAL_SET_T

#include <list>

class plot_t;
class line_real_t;

/** lots of real lines, corresponding to:
      same type of y-variable 
      same going-to-be window size
*/
class line_real_set_t {
  int minX, maxX;
  double minY, maxY;
  typedef std::list<line_real_t> line_real_list_t;
  line_real_list_t data;
  friend class plot_t;
public:
  line_real_set_t(int minXin, int maxXin, double minYin, double maxYin);
  void add(line_real_t& line_real);
  bool empty();
  void clear();
  int getMinX();
  int getMaxX();
  double getMinY();
  double getMaxY();
  //  void show();
}; // --class line_real_set_t
#endif
