/** @file line_window_t.hpp
    @package snark14Display
    @author Bruno M. Carvalho and Deniz Sarioz
    licensed under (open-source) QPL v1.0
    which accompanies this distribution in the file QPL
*/

#ifndef _LINE_WINDOW_T
#define _LINE_WINDOW_T

#include <list>

class QPainter;
class QColor;

class point_window_t;

/** these correspond to segments */
class line_window_t
{
  typedef std::list<point_window_t> data_window_t;
  data_window_t data;
public:
  void add(int x, int y);

  void add(point_window_t& ptw);

  bool empty();
  
  void clear();

  /** pre: all coordinates are within paint's win          */
  /* (i.e., all points in data ought to be within window.) */
  void plot(QPainter& P, QColor& C, Qt::PenStyle & Ps);

  void show();

}; // -- class line_window_t

#endif
