/** @file punch.cpp
    @package snark14Input
    @author Bruno M. Carvalho and Deniz Sarioz
    licensed under (open-source) QPL v1.0
    which accompanies this distribution in the file QPL
*/

/****************************************************************************
** Form implementation generated from reading ui file 'punch.ui'
**
** Created: Wed May 15 18:20:01 2002
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "punch.h"
#include "misc.h"
#include "variables.h"

#include <qcheckbox.h>
#include <qframe.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qmessagebox.h>

/** 
 *  Constructs a punchwindow which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
@param void
@author Bruno M. Carvalho
@version 1.0 */
punchwindow::punchwindow( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "punchwindow" );
    resize( 400, 300 ); 
    setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, sizePolicy().hasHeightForWidth() ) );
    setMinimumSize( QSize( 400, 240 ) );
    setMaximumSize( QSize( 400, 240 ) );
    setCaption( tr( "Punch Window" ) );

    punchlabel = new QLabel( this, "punchlabel" );
    punchlabel->setGeometry( QRect( 10, 10, 100, 30 ) ); 
    punchlabel->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, punchlabel->sizePolicy().hasHeightForWidth() ) );
    punchlabel->setMinimumSize( QSize( 100, 30 ) );
    punchlabel->setMaximumSize( QSize( 100, 30 ) );
    punchlabel->setText( tr( "PUNCH" ) );

    phantombox = new QCheckBox( this, "phantombox" );
    phantombox->setGeometry( QRect( 30, 60, 110, 30 ) ); 
    phantombox->setText( tr( "PHANTOM" ) );

    iterationflaglabel = new QLabel( this, "iterationflaglabel" );
    iterationflaglabel->setGeometry( QRect( 130, 100, 130, 20 ) ); 
    iterationflaglabel->setText( tr( "iteration_flag_line" ) );

    iterationflagline = new QLineEdit( this, "iterationflagline" );
    iterationflagline->setGeometry( QRect( 50, 120, 290, 30 ) ); 
    iterationflagline->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, iterationflagline->sizePolicy().hasHeightForWidth() ) ); 

    Line11 = new QFrame( this, "Line11" );
    Line11->setGeometry( QRect( 0, 165, 400, 16 ) ); 
    Line11->setFrameStyle( QFrame::HLine | QFrame::Sunken );

    okbutton = new QPushButton( this, "okbutton" );
    okbutton->setGeometry( QRect( 50, 180, 100, 40 ) ); 
    okbutton->setText( tr( "OK" ) );
    QObject::connect(okbutton,SIGNAL(clicked()),this,SLOT(checkValues()));

    cancelbutton = new QPushButton( this, "cancelbutton" );
    cancelbutton->setGeometry( QRect( 250, 180, 100, 40 ) ); 
    cancelbutton->setText( tr( "Cancel" ) );
    QObject::connect(cancelbutton,SIGNAL(clicked()),this,SLOT(reject()));
}

/**  
 *  Destroys the object and frees any allocated resources
 */
punchwindow::~punchwindow()
{
    // no need to delete child widgets, Qt does it all for us
}


/** Returns a string for PUNCH input sequence
@param void
@return punch
@author Bruno M. Carvalho
@version 1.0 */
QString punchwindow::getOutput()
{
  QString output;

  output.sprintf("PUNCH ");
  if(phantombox->isChecked()) {
    output.append("PHANTOM ");
  }
  output.append("\n");
  output+=iterationflagline->text();
  
  return output;
}

void punchwindow::checkValues()
{
  int f=0;

  if(!isintspace(iterationflagline->text()))
    f=1;
  switch(f) {
  case 0: accept();
    break;
  case 1: QMessageBox::information(this,"SnarkInput","Error!\n"
                                   "iteration_flag_line must contain\n"
                                   "only 0-9 and spaces and must\n"
                                   "be non-empty");
    break;
  }
}
